
From: viro@parcelfarce.linux.theplanet.co.uk

On Wed, Aug 27, 2003 at 01:46:37AM -0700, Andrew Morton wrote:
> 
> LILO seems to be oopsing in HDIO_GETGEO ioctl for some reason, in
> generic_ide_ioctl().
> 
> I'm not sure quite why though.  Could one of your patches affected this
> area?

The last one (fix for hd_struct handling).  The fix follows:



 include/linux/genhd.h |    2 +-
 1 files changed, 1 insertion(+), 1 deletion(-)

diff -puN include/linux/genhd.h~large-dev_t-12-fix include/linux/genhd.h
--- 25/include/linux/genhd.h~large-dev_t-12-fix	2003-08-27 10:36:32.000000000 -0700
+++ 25-akpm/include/linux/genhd.h	2003-08-27 10:36:32.000000000 -0700
@@ -197,7 +197,7 @@ extern void rand_initialize_disk(struct 
 
 static inline sector_t get_start_sect(struct block_device *bdev)
 {
-	return bdev->bd_part->start_sect;
+	return bdev->bd_contains == bdev ? 0 : bdev->bd_part->start_sect;
 }
 static inline sector_t get_capacity(struct gendisk *disk)
 {

_
